/**
 * 
 */
package Examples;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.util.HashMap;
import java.util.Set;

import policy.HIPAAQuery;
import policy.HIPAAResult;

/**
 * @author Nipun Dave
 *
 */
public class ReadHIPAAPolicy implements Serializable{

	private static final long serialVersionUID = 1L;
	public static String policyStoreFileName = "Policy/HIPAAPolicyJava.ser";
	
	@SuppressWarnings("unchecked")
	public static void main(String[] args) {
		try {
			HashMap<String, Set<HIPAAResult>> policy = (HashMap<String, Set<HIPAAResult>>)unserializeObject(policyStoreFileName);
			HIPAAQuery q = new HIPAAQuery("doctor", "teen", "phi", "compliance");
			System.out.println("query hash = " + q.toString());
			Set<HIPAAResult> possibleResults = policy.get(q.toString());			
			System.out.println(possibleResults);
			
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

	}
	
	public static Object unserializeObject(String fileName) throws ClassNotFoundException{
		 try {
			 FileInputStream fis = new FileInputStream(fileName);
			 ObjectInputStream in = new ObjectInputStream(fis);
			 return in.readObject();
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
	}

}
