package wrapper;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Properties;

import javax.crypto.SecretKey;

import security.abemodule.accesscontrol.AccessController;
import security.abemodule.documentencryptiondecryption.DesEncrypter;
import security.abemodule.documentencryptiondecryption.DesEncrypterWrapper;
import security.abemodule.keygeneration.KeyGenerator;


// all paths (except for fileEncryptionKeyName and encryptedKeyName) need to be absolute

public class DecryptionModule {
	
	public String userKeyPath;
	public String userKeyName;
	public String attributes;
	public String policies;
	public String abeEncryptedKeyPath;
	public String abeEncryptedKeyName;
	public String desEncryptedFilePath;
	public String desEncryptedFileName;
	public String decryptedFilePath;
	public String decryptedFileName;
	public int numberOfEncryptedKeys;
	private String abe_lib_location = "/Users/frankwang/Desktop/fenc-0.2.0/tools/";
	private String abe_path = "/Users/frankwang/Desktop/ABE/";

	public boolean decrypt(){
		String decryptedKey="";
		DesEncrypterWrapper wrapper = new DesEncrypterWrapper();
		boolean found = false;
		
		for (int i=0;i<numberOfEncryptedKeys;i++){
			NumberFormat form = new DecimalFormat("000");
			AccessController accesscontroller = new AccessController(abeEncryptedKeyPath+"/"+abeEncryptedKeyName+form.format(i)+".cpabe",userKeyPath+"/"+userKeyName,abe_lib_location);
			accesscontroller.accessDocument();
			try {		 
		        String sCurrentLine;
		        BufferedReader br = 
		             new BufferedReader(new FileReader(abe_path+"a.out"));
		        
		        while ((sCurrentLine = br.readLine()) != null) {
			       if(sCurrentLine.contains("Plaintext") && sCurrentLine.contains("Key-")){
			    	   found = true;
			    	   decryptedKey = sCurrentLine.substring(sCurrentLine.indexOf("-")+1);
			    	   break;
			       }
			 }          
		    } catch (FileNotFoundException e) {
		      e.printStackTrace(); 
		    } catch (IOException e) {	 
		      e.printStackTrace();		 
		    }
		    if (found)
		    	break;
		}
		if(found){
			try{
				FileWriter temp = new FileWriter(new File(abe_path+"temp.key"));
				temp.write(decryptedKey);
				temp.close();
			}catch (Exception e){
				e.printStackTrace();
				found = false;
			}
			SecretKey newKey = wrapper.retrieveDesKey(abe_path+"temp.key");
			DesEncrypter newEncrypter;
			try {
				newEncrypter = new DesEncrypter(newKey);
				newEncrypter.decrypt(new FileInputStream(desEncryptedFilePath+"/"+desEncryptedFileName), new FileOutputStream(decryptedFilePath+"/"+decryptedFileName));
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				found = false;
			}
			
		}
		return found;	
	}
	
	public void generateABEKey(){
		KeyGenerator keygenerator = new KeyGenerator(userKeyPath, abe_lib_location);	
		keygenerator.gotokeygeneratorpath();
		keygenerator.generateABEKey(userKeyName, attributes,policies);
	}
}