package wrapper;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Properties;
import java.util.Set;

import javax.crypto.SecretKey;

import policy.HIPAAQuery;
import policy.HIPAAResult;
import policy.ReadHIPAAPolicy;
import security.abemodule.documentencryptiondecryption.DesEncrypter;
import security.abemodule.documentencryptiondecryption.DesEncrypterWrapper;
import security.abemodule.encryption.DocumentEncryptor;
import security.abemodule.utility.HipaaResultFormatter;

public class EncryptionTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String policyStoreFileName = "/Users/frankwang/Desktop/healthcareproj2/IHI/HIPAA_ABE_Encryption/src/policy/HIPAAPolicyJava.ser";
		String desFileEncryptionKeyName = "/Users/frankwang/Desktop/healthcareproj2/IHI/HIPAA_ABE_Encryption/DESKey.txt";
		String toBeEncryptedFilePath = "/Users/frankwang/Desktop/ABE/random.txt";
		String encryptedFilePath = "/Users/frankwang/Desktop/ABE/encryptedFile.txt";
		String abeEncryptedKeys = "/Users/frankwang/Desktop/ABE/encryptedKey";
		String desFileEncryptionKeyPath = "/Users/frankwang/Desktop/healthcareproj2/IHI/HIPAA_ABE_Encrpytion";
		HIPAAQuery q = new HIPAAQuery("doctor","kid","phi","requested_by_Individual");
		
		DesEncrypterWrapper wrapper = new DesEncrypterWrapper();
		SecretKey key = wrapper.generateDesKey();
		//System.out.println(key.toString());
		wrapper.saveDesKey(key, desFileEncryptionKeyName);
		DesEncrypter encrypter;
		try {
			encrypter = new DesEncrypter(key);
			encrypter.encrypt(new FileInputStream(toBeEncryptedFilePath), new FileOutputStream(encryptedFilePath));
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		
		HashMap<String, Set<HIPAAResult>> policy = null;
		try {
			policy = (HashMap<String, Set<HIPAAResult>>)ReadHIPAAPolicy.unserializeObject(policyStoreFileName);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		//System.out.println(policy);
		//System.out.println("query hash = " + q.toString());
		Set<HIPAAResult> possibleResults = policy.get(q.toString());			
		//System.out.println(possibleResults);
		HipaaResultFormatter h = new HipaaResultFormatter(possibleResults);
		Properties prop = new Properties();
		try{
			prop.load(new FileInputStream("filepath.properties"));
			
		}
		catch (IOException e){
		}
		DocumentEncryptor documentencryptor = new DocumentEncryptor(prop.getProperty("abe_lib_location"), desFileEncryptionKeyName,desFileEncryptionKeyPath);	
		documentencryptor.gotokeydir();
		ArrayList<String> attributeList = h.stringFormat();
		//for (int i = 0; i < attributeList.size(); i++)
			//System.out.println("attr1:" + attributeList.get(i));
		int count = documentencryptor.encryptDocumentUsingAttributeList(attributeList, abeEncryptedKeys);
		//System.out.println("count:" + count);

	}

}
